<template>
  <div id="contenedor">
    <span id="titulo">Estudiante</span>
    <br />
    <!-------FORMULARIO------->
    <v-form ref="form" v-model="valid" lazy-validation>
      <!----Fila 1---->
      <v-row>
        <!---Columna 1 --->
        <v-col cols="6" sm="6" md="6">
          <!---Nombre-->
          <v-text-field
            v-model="nombre"
            :counter="50"
            :rules="nombreRules"
            label="Nombre"
            required
            outlined
          ></v-text-field>
        </v-col>
        <!---Columna 2 --->
        <v-col cols="6" sm="6" md="6">
          <!-----Teléfono-->
          <v-text-field
            v-model="telefono"
            :rules="telefonoRules"
            :counter="12"
            label="Teléfono"
            required
            outlined
          ></v-text-field>
        </v-col>
      </v-row>

      <!----Fila 2---->
      <v-row>
        <!---Columna 1 --->
        <v-col cols="6" sm="6" md="6">
          <!---Apellido-->
          <v-text-field
            v-model="apellido"
            :counter="50"
            :rules="nombreRules"
            label="Apellido"
            required
            outlined
          ></v-text-field>
        </v-col>
        <!---Columna 2 --->
        <v-col cols="6" sm="6" md="6">
          <!----Cédula---->
          <v-text-field
            v-model="cedula"
            :rules="cedulaRules"
            :counter="10"
            label="Cédula"
            required
            outlined
            type="number"
          ></v-text-field>
        </v-col>
      </v-row>

      <!----Fila 3---->
      <v-row>
        <!---Columna 1 --->
        <v-col cols="6" sm="6" md="6">
          <!----Email---->
          <v-text-field
            v-model="email"
            :rules="emailRules"
            label="Email"
            required
            outlined
          ></v-text-field>
        </v-col>
        <!---Columna 2 --->
        <v-col cols="6" sm="6" md="6">
          <!---Carrera-->
          <v-select
            v-model="select_carrera"
            :items="carreras"
            :rules="[(v) => !!v || 'Item is required']"
            label="Carrera"
            required
            outlined
          ></v-select>
        </v-col>
      </v-row>

      <!----Fila 4---->
      <v-row>
        <!---Columna 1 --->
        <v-col cols="6" sm="6" md="6">
          <!----Género--->
          <v-select
            v-model="select_genero"
            :items="genero"
            :rules="[(v) => !!v || 'Item requerido']"
            label="Género"
            required
            outlined
          ></v-select>
        </v-col>
        <!---Columna 2 --->
        <v-col cols="6" sm="6" md="6">
          <!----Ciudad--->
          <v-select
            v-model="select_ciudad"
            :items="municipios"
            :rules="[(v) => !!v || 'Item requerido']"
            label="Municipio"
            item-text="municipio"
            item-value="municipio"
            required
            outlined
          ></v-select>
        </v-col>
      </v-row>

      <v-btn :disabled="!valid" color="success" class="mr-4" @click="registrar">
        Registrar
      </v-btn>
    </v-form>
  </div>
</template>

<script>
import store from '../store/index.js';

export default {
  data: () => {
    return {
      valid: true,
      nombre: "",
      apellido: "",
      telefono: "",
      cedula: "",
      email: "",
      nombreRules: [
        (v) => !!v || "Este campo es requerido",
        (v) => (v && v.length <= 50) || "MÁXIMO 50 caracteres",
      ],
      telefonoRules: [
        (v) => !!v || "Este campo es requerido",
        (v) => (v && v.length <= 12) || "MÁXIMO 12 caracteres",
      ],
      cedulaRules: [
        (v) => !!v || "Este campo es requerido",
        (v) => (v && v.length <= 10) || "MÁXIMO 10 caracteres",
      ],
      emailRules: [
        (v) => !!v || "E-mail is required",
        (v) => /.+@.+\..+/.test(v) || "Ingrese un email válido",
      ],
      select_carrera: null,
      select_genero: null,
      select_ciudad: null,
      carreras: ["Ingeniería de software", "Matemáticas", "Diseño gráfico", "Ingeniería ambiental"],
      genero: ["Masculino", "Femenino"]
    };
  },
  methods: {
    registrar() {
      if(this.$refs.form.validate()){
        let objEstudiante = {
          nombre: this.nombre,
          apellido: this.apellido,
          email: this.email,
          telefono: this.telefono,
          genero: this.select_genero,
          cedula: this.cedula,
          carrera: this.select_carrera,
          ciudad: this.select_ciudad
        } 
        //Llamar las acciones del store
        store.dispatch('registrarEstudiante', objEstudiante);
        this.$refs.form.reset();
      }
    },    
  },
  //Función que se ejecuta al crear el componente
  created: ()=>{
    store.dispatch('cargarMunicipios');
  },
  //Propiedades computadas (observable)
  computed: {
    municipios: ()=>{
      return store.state.municipios;
    }
  }
};
</script>

<style>
#contenedor {
  text-align: center;
}
#titulo {
  font-size: 3rem;
  font-weight: bold;
}
v-row{
  margin: 0px;
  padding: 0px;
}
v-col{
  margin: 0px;
  padding: 0px;
}
</style>